<?php

$pth = str_replace("/scripts","",dirname(__FILE__));

if (file_exists("$pth/include/global.php"))
    include("$pth/include/global.php");
else
    include("$pth/include/config.php");

include("$pth/lib/snmp.php");

function snmp_data($oid) {
    global $snmp_details;
    $d=$snmp_details;
    $counter=cacti_snmp_get($d['hostname'], $d['community'], $oid, $d['version'], $d['username'], $d['password'], $d['auth_proto'], $d['priv_pass'], $d['priv_proto'], $d['context']);
    if ($counter===false || $counter=="" || $counter=="U" || stristr($counter,"No Such"))
	return false;
    return trim(substr($counter,strrpos($counter,":")+2));
}

function snmp_data_array($oid) {
    global $snmp_details;
    $d=$snmp_details;
    
    snmp_set_oid_numeric_print(1);
    snmp_set_enum_print(TRUE);

    $array=cacti_snmp_walk($d['hostname'], $d['community'], $oid, $d['version'], $d['username'], $d['password'], $d['auth_proto'], $d['priv_pass'], $d['priv_proto'], $d['context']);
    return $array;
}

/*
 * splits string into chunks and returns them as an array (implies str_split on php5)
 */
function str_splt($text, $split = 1) {

    if (function_exists('str_split'))
        return str_split($text,$split);

    if (!is_string($text) || (!is_numeric($split) || $split < 1) ) return false;

    $len = strlen($text);
    $array = array();
    $i = 0;

    while ($i < $len) {
        $key = NULL;

        for ($j = 0; $j < $split; $j += 1) {
            if ($i == $len) break;
            $key .= $text{$i};
            $i += 1;
        }

        $array[] = $key;
    }

    return $array;
}

?>
