#!/usr/bin/php
<?php
include "functions.php";
global $oids, $snmp_details;

//JUNIPER-FIREWALL-MIB::

//this array came from cisco qos and car templates script and is foreseen for future use
$oids = array (
		'indexes'	=>	'.1.3.6.1.4.1.2636.3.5.2.1.5',	//jnxFWCounterByteCount
		);

$auth=explode("::",$_SERVER['argv'][2]);

$snmp_details['hostname']=$_SERVER['argv'][1];
$snmp_details['community']=$auth[1];
$snmp_details['version']=$auth[0];
$snmp_details['username']=$auth[2];
$snmp_details['password']=$auth[3];
$snmp_details['auth_proto']=$auth[4];
$snmp_details['priv_pass']=$auth[5];
$snmp_details['priv_proto']=$auth[6];
$snmp_details['context']=$auth[7];
$oid=(isset($_SERVER['argv'][5])) ? $_SERVER['argv'][5] : false;

$task=$_SERVER['argv'][3];
$target=(isset($_SERVER['argv'][4]) ? $_SERVER['argv'][4] : false);
 
if ($task=='query' || $task=='index') {
    if ($task=='index') $target='index';
    
    $indexes=response("indexes");
    foreach ($indexes as $indexOid => $indexVal) {
	$index = str_replace($oids["indexes"].".","",$indexOid);
	$index=explode(".",$index);
	
	$pol_tmp_nm_len=$index[0];	//policer template name length
	$pol_tmp_nm="";			//policer template name
	$pol_nm="";			//policer name
	for ($i=1; $i<($pol_tmp_nm_len+1); $i++) {
	    $pol_tmp_nm .=chr( $index[$i]);
	}
	for ($j=($i+1);$j<(count($index)-1);$j++) {
	    $pol_nm.=chr($index[$j]);
	}
	
	$structure['"'.$pol_tmp_nm.".".$pol_nm."||".end($index)."||".strlen($pol_tmp_nm).'"'] = array(
				"policer_template"=>$pol_tmp_nm,
				"policer_name"=>$pol_nm,
				"type" => (end($index)==2 ? "counter" : "policer"),
				"value"=>$indexVal
				);
    }

    switch ($target) {
    case "index":
	foreach ($structure as $struct_id => $struct_val) {
	    if ($task=='query') 
		echo "$struct_id::$struct_id\n";
	    else
		echo $struct_id."\n";
	}
	break;
    case "template":
	foreach ($structure as $struct_id => $struct_val) {
		echo $struct_id."::".$struct_val['policer_template']."\n";
	}
	break;
    case "policer":
	foreach ($structure as $struct_id => $struct_val) {
		echo $struct_id."::".$struct_val['policer_name']."\n";
	}
	break;
    case "type":
	foreach ($structure as $struct_id => $struct_val) {
		echo $struct_id."::".$struct_val["type"]."\n";
	}
	break;
    case "direction":
	foreach ($structure as $struct_id => $struct_val) {
		$str=$struct_val['policer_template'].".".$struct_val['policer_name'];

		if ( stristr($str,"_in") && !(stristr($str,"_out")) ) 
		    $dirct = "&nbsp;<font color=green>&darr;</font>input";
		elseif ( stristr($str,"_out") && !(stristr($str,"_in")) )
		    $dirct = "&nbsp;<font color=blue>&uarr;</font>output";
		elseif ( stristr($str,"_out") && (stristr($str,"_in")) )
		    $dirct = "&nbsp;<font color=blue>&uarr;</font>&nbsp;<font color=green>&darr;</font>out&in";
		else
		    $dirct="n/a";
		
		echo $struct_id."::".$dirct."\n";
	}
	break;
    case "counter":
	foreach ($structure as $struct_id => $struct_val) {
		echo $struct_id."::".$struct_val["value"]."\n";
	}
	break;
    default:
	die("klaidingas parametras\n");
    }
} elseif ($task=='get' && $target=='ByteCount') {
    $det = substr($oid,strpos($oid,"||")+2);	//strip trailing (||2||11)
    $oid = substr($oid,0,strpos($oid,"||"));	//strip $det from $oid (policer-template.policer-name)
    $det=explode("||",$det);			//array(0=>[policer(3) or counter(2)], 1=>[policer-template.lenght])
    
    $pol_tmp_nm = substr($oid,0,$det[1]);	//policer template name
    $pol_nm = substr($oid,($det[1]+1));		//policer name
    $oid=$det[1];				//policer template name lenght
    $pol_tmp_nms = str_splt($pol_tmp_nm);

    foreach ($pol_tmp_nms as $chr) {
	$oid.=".".ord($chr);			//ascii->dec
    }

    $pol_nms = str_split($pol_nm);
    $oid .= ".".count($pol_nms);
    
    foreach ($pol_nms as $chr) {
	$oid.=".".ord($chr);
    }

    $oid .= ".".$det[0];				//policer or counter type
    $result = snmp_data($oids["indexes"].".$oid");
    echo (intval($result)==0) ? 0 : $result;
} else {
    die("nepakanka parametru\n");
}

function response($task) {
    global $snmp_details,$oids;
    $results=false;

    $query = snmp_data_array($oids[$task]);

    foreach ($query as $ind => $q) {
	$results[".".$q['oid']]=$q['value'];
    }
    return $results;
}

?>